
/**
 * Module Dependencies.
 */

var deref = require('json-schema-deref-sync');
var normalize = require('./normalize');
var debug = require('debug')('jsg');
var Source = require('./source');

/**
 * Expose `Generator`
 */

module.exports = Generator;

/**
 * Expose `Source`
 */

Generator.Source = Source;

/**
 * Initialize `Generator`
 */

function Generator(schema, src){
  this.schema = deref(schema);
  this.schema = normalize(this.schema);
  this.source = src || new Source;
}

/**
 * Generate generates json schema
 * and calls the given `fn`.
 */

Generator.prototype.generate = function(fn){
  debug('generate %j', this.schema.title);
  return this.source.generate('', this.schema);
};
