
var Validator = require('is-my-json-valid');
var readdir = require('fs').readdirSync;
var chance = require('chance')();
var Generator = require('..');
var assert = require('assert');

describe('test', function(){
  readdir('test/fixtures').forEach(function(name){
    it(name, function(){
      var schema = require('./fixtures/' + name);
      var g = new Generator(schema);
      var v = new Validator(schema, { greedy: true, verbose: true });

      g.source.path({
        first_name: function(){ return chance.first(); },
        age: function(){ return chance.age(); },
        email: function(){ return chance.email(); },
        website: function(){ return chance.url(); }
      });

      var obj = g.generate();
      var valid = v(obj);
      assert(valid, name + ': ' + JSON.stringify(v.errors));
    })
  });
})